/* Problem URL: https://codeforces.com/problemset/problem/1996/F */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    int n;
    ll k;
    cin >> n >> k;

    vl a(n);
    vl b(n);
    cin >> a >> b;

    ll low = 0;
    ll high = 1e9;
    ll act = 1e9;
    while (low <= high) {
        ll mid = (low + high) >> 1;

        ll cos = 0;
        rep(i, n) {
            cos += max((a[i] - mid + b[i] - 1) / b[i], 0LL);
        }

        if (cos <= k) {
            act = mid;
            high = mid - 1;
            continue;
        }

        low = mid + 1;
    }
    
    ll ans = 0;
    ll cos = 0;
    priority_queue<pair<ll, ll>> pq;
    rep(i, n) {
        ll t = max((a[i] - act + b[i] - 1) / b[i], 0LL);
        cos += t;

        ll mod = a[i] % b[i];
        ll add = t * (a[i] / b[i] * 2 - t + 1) / 2 * b[i] + mod * t;
        a[i] -= b[i] * t;
        ans += add;
        pq.emplace(max(a[i], 0LL), b[i]);
    }

    k -= cos;

    while (k > 0) {
        auto [x, y] = pq.top();
        if (x == 0) {
            break;
        }
        pq.pop();
        ans += x;
        pq.emplace(max(x - y, 0LL), y);
        k--;
    }

    cout << ans << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
